/* gpfact.cc: implementation of integer factorization using pari
   library with interfact via strings */

#ifdef USE_PARI_FACTORING

#include "pari/pari.h"
#include "parifact.h"

//#define DEBUG_GPFACT
#include <iostream>

/*
GEN
factor_gen(GEN n)
{
  return gtovec((GEN)factor(n)[1]);
}
*/

char* 
factor(const char* n)
{
  if (!bot) {
    pari_init(1000000, 1000000);
  }
#ifdef DEBUG_GPFACT
  std::cout<<"factor called with "<<n<<endl;
#endif
  //  GEN x = strtoi((char*)n); // pari 2.2.11 1.1281

  pari_sp av=avma;  // store pari stack pointer
  GEN x = strtoi((char*)n);
  setsigne(x,1);
  x = gel(decomp(x),1);
  settyp(x,t_VEC);
  
  char* ans = GENtostr(x); 
  avma=av;         // restore pari stackpointer
  return ans;
}

#endif
