"""
Algebras
"""

#*****************************************************************************
#       Copyright (C) 2005 William Stein <wstein@ucsd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

# Algebra base classes
from algebra import Algebra, is_Algebra
from commutative_algebra import CommutativeAlgebra, is_CommutativeAlgebra

# Ring element base classes
from algebra_element import AlgebraElement, is_AlgebraElement
from commutative_algebra_element import CommutativeAlgebraElement, is_CommutativeAlgebraElement

##############################################################
# Should determine which functions are intended for export
##############################################################

from free_algebra import FreeAlgebra
#from free_algebra_element import *
from free_algebra_quotient import FreeAlgebraQuotient
#from free_algebra_quotient_element import *
#from algebra_order import AlgebraOrder_generic
#from algebra_order_element import *
#from algebra_ideal import *
#from algebra_ideal_element import *
#from algebra_order_ideal import *
#from algebra_order_ideal_element import *
from quaternion_algebra import QuaternionAlgebra, QuaternionAlgebraWithInnerProduct, QuaternionAlgebraWithGramMatrix, QuaternionAlgebraWithDiscriminants
#from quaternion_algebra_element import *
from quaternion_order import QuaternionOrderWithBasis, QuaternionDefiningOrder
#from quaternion_order_element import *
from quaternion_order_ideal import QuaternionOrderLeftIdeal, QuaternionOrderRightIdeal, QuaternionOrderTwoSidedIdeal
#from quaternion_order_ideal_element import *

##############################################################
# For checking that documentation strings are correct.
##############################################################
if __name__ ==  '__main__':
    import doctest, sys
    doctest.testmod(sys.modules[__name__])
    



