"""
Interface to the SAGE interpreter (!)
"""

#*****************************************************************************
#       Copyright (C) 2005 William Stein <wstein@ucsd.edu>
#
#  Distributed under the terms of the GNU General Public License (GPL)
#
#    This code is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    General Public License for more details.
#
#  The full text of the GPL is available at:
#
#                  http://www.gnu.org/licenses/
#*****************************************************************************

from expect import Expect

class Sage(Expect):
    def __init__(self, maxread=10000, script_subdirectory="user"):
        Expect.__init__(self,
                        name = 'sage',
                        prompt = 'sage: ',
                        command = "sage",
                        maxread = maxread,
                        script_subdirectory = script_subdirectory,
                        restart_on_ctrlc = False)

    def __call__(self, line):
        """
        Send the code x to a second instance of the SAGE interpreter and
        return the output as a string.

        This allows you to run two completely independent copies of SAGE
        at the same time in a unified way.
        """
        L = Expect.__call__(self, line)
        i = L.find("[0m")
        if i == -1:
            return L
        return L[i+3:]

sage0 = Sage()

import os
def sage0_console():
    os.system('sage')

#def irun(filename):
#    """
#    Run the script in filename step-by-step displaying each input line
#
#    This does not work right with for loops, which span multiple lines.
#    """
#    print 'Interactive runing "%s"'%filename
#    for L in open(filename).xreadlines():
#        raw_input("sage: "+L[:-1])
#        print sage0(L)[:-1]

