cdef extern from "Python.h":
    object PyString_FromString(char *v)
    char* PyString_AsString(object string)

cdef extern from "stdlib.h":
    void free(void *ptr)

cdef extern from "wrap.h":
    #### ZZ
    struct ZZ
    ZZ* new_ZZ()
    ZZ* str_to_ZZ(char* s)
    void del_ZZ(ZZ* n)
    char* ZZ_to_str(ZZ* x)
    ZZ* ZZ_add(ZZ* x, ZZ* y)
    ZZ* ZZ_sub(ZZ* x, ZZ* y)
    ZZ* ZZ_mul(ZZ* x, ZZ* y)
    ZZ* ZZ_pow(ZZ* x, long e)
    int ZZ_is_one(ZZ* x)
    int ZZ_is_zero(ZZ* x)
    ZZ* ZZ_neg(ZZ* x)
    ZZ* ZZ_copy(ZZ* x)
    

    #### ZZ_p
    struct ZZ_p
    ZZ_p* new_ZZ_p()
    ZZ_p* str_to_ZZ_p(char* s)
    void del_ZZ_p(ZZ_p* n)
    char* ZZ_p_to_str(ZZ_p* x)
    ZZ_p* ZZ_p_add(ZZ_p* x, ZZ_p* y)
    ZZ_p* ZZ_p_sub(ZZ_p* x, ZZ_p* y)
    ZZ_p* ZZ_p_mul(ZZ_p* x, ZZ_p* y)
    ZZ_p* ZZ_p_pow(ZZ_p* x, long e)
    int ZZ_p_is_one(ZZ_p* x)
    int ZZ_p_is_zero(ZZ_p* x)
    ZZ_p* ZZ_p_neg(ZZ_p* x)
    void ntl_ZZ_set_modulus(ZZ* x)
    int ZZ_p_eq( ZZ_p* x,  ZZ_p* y)
    ZZ_p* ZZ_p_inv(ZZ_p* x)
    ZZ_p* ZZ_p_random()

    #### ZZX
    struct ZZX
    ZZX* ZZX_init()
    ZZX* str_to_ZZX(char* s)
    char* ZZX_repr(ZZX* x)
    void ZZX_dealloc(ZZX* x)
    ZZX* ZZX_copy(ZZX* x)
    void ZZX_setitem(ZZX* x, long i, char* a)
    char* ZZX_getitem(ZZX* x, long i)
    ZZX* ZZX_add(ZZX* x, ZZX* y)
    ZZX* ZZX_sub(ZZX* x, ZZX* y)
    ZZX* ZZX_mul(ZZX* x, ZZX* y)
    ZZX* ZZX_div(ZZX* x, ZZX* y, int* divisible)
    ZZX* ZZX_mod(ZZX* x, ZZX* y)
    void ZZX_quo_rem(ZZX* x, ZZX* other, ZZX** r, ZZX** q)
    ZZX* ZZX_square(ZZX* x)
    int ZZX_equal(ZZX* x, ZZX* y)
    int ZZX_is_zero(ZZX* x)
    int ZZX_is_one(ZZX* x)
    int ZZX_is_monic(ZZX* x)
    ZZX* ZZX_neg(ZZX* x)
    ZZX* ZZX_left_shift(ZZX* x, long n)
    ZZX* ZZX_right_shift(ZZX* x, long n)
    char* ZZX_content(ZZX* x)
    ZZX* ZZX_primitive_part(ZZX* x)
    void ZZX_pseudo_quo_rem(ZZX* x, ZZX* y, ZZX** r, ZZX** q)
    ZZX* ZZX_gcd(ZZX* x, ZZX* y)
    ZZX* ZZX_xgcd(ZZX* x, ZZX* y, ZZ** r, ZZX** s, ZZX** t, int proof)
    long ZZX_degree(ZZX* x)
    ZZ* ZZX_leading_coefficient(ZZX* x)
    char* ZZX_constant_term(ZZX* x)
    void ZZX_set_x(ZZX* x)
    int ZZX_is_x(ZZX* x)
    ZZX* ZZX_derivative(ZZX* x)
    ZZX* ZZX_reverse(ZZX* x)
    ZZX* ZZX_reverse_hi(ZZX* x, long hi)
    ZZX* ZZX_truncate(ZZX* x, long m)
    ZZX* ZZX_multiply_and_truncate(ZZX* x, ZZX* y, long m)
    ZZX* ZZX_square_and_truncate(ZZX* x, long m)
    ZZX* ZZX_invert_and_truncate(ZZX* x, long m)
    ZZX* ZZX_multiply_mod(ZZX* x, ZZX* y,  ZZX* modulus)
    ZZ* ZZX_trace_mod(ZZX* x, ZZX* y)
    char* ZZX_trace_list(ZZX* x)
    ZZ* ZZX_resultant(ZZX* x, ZZX* y, int proof)
    ZZ* ZZX_norm_mod(ZZX* x, ZZX* y, int proof)
    ZZ* ZZX_discriminant(ZZX* x, int proof)
    ZZX* ZZX_charpoly_mod(ZZX* x, ZZX* y, int proof)
    ZZX* ZZX_minpoly_mod(ZZX* x, ZZX* y)
    void ZZX_clear(ZZX* x)
    void ZZX_preallocate_space(ZZX* x, long n)
    

    #### ZZ_pX
    struct ZZ_pX
    ZZ_pX* ZZ_pX_init()
    ZZ_pX* str_to_ZZ_pX(char* s)
    char* ZZ_pX_repr(ZZ_pX* x)
    void ZZ_pX_dealloc(ZZ_pX* x)
    ZZ_pX* ZZ_pX_copy(ZZ_pX* x)
    void ZZ_pX_setitem(ZZ_pX* x, long i, char* a)
    char* ZZ_pX_getitem(ZZ_pX* x, long i)
    ZZ_pX* ZZ_pX_add(ZZ_pX* x, ZZ_pX* y)
    ZZ_pX* ZZ_pX_sub(ZZ_pX* x, ZZ_pX* y)
    ZZ_pX* ZZ_pX_mul(ZZ_pX* x, ZZ_pX* y)
    ZZ_pX* ZZ_pX_div(ZZ_pX* x, ZZ_pX* y, int* divisible)
    ZZ_pX* ZZ_pX_mod(ZZ_pX* x, ZZ_pX* y)
    void ZZ_pX_quo_rem(ZZ_pX* x, ZZ_pX* other, ZZ_pX** r, ZZ_pX** q)
    ZZ_pX* ZZ_pX_square(ZZ_pX* x)
    int ZZ_pX_equal(ZZ_pX* x, ZZ_pX* y)
    int ZZ_pX_is_zero(ZZ_pX* x)
    int ZZ_pX_is_one(ZZ_pX* x)
    int ZZ_pX_is_monic(ZZ_pX* x)
    ZZ_pX* ZZ_pX_neg(ZZ_pX* x)
    ZZ_pX* ZZ_pX_left_shift(ZZ_pX* x, long n)
    ZZ_pX* ZZ_pX_right_shift(ZZ_pX* x, long n)
    ZZ_pX* ZZ_pX_gcd(ZZ_pX* x, ZZ_pX* y)
    ZZ_pX* ZZ_pX_xgcd(ZZ_pX** d, ZZ_pX** s, ZZ_pX** t, ZZ_pX* a, ZZ_pX* b)
    ZZ_pX* ZZ_pX_plain_xgcd(ZZ_pX** d, ZZ_pX** s, ZZ_pX** t, ZZ_pX* a, ZZ_pX* b)
    long ZZ_pX_degree(ZZ_pX* x)
    ZZ_p* ZZ_pX_leading_coefficient(ZZ_pX* x)
    char* ZZ_pX_constant_term(ZZ_pX* x)
    void ZZ_pX_set_x(ZZ_pX* x)
    int ZZ_pX_is_x(ZZ_pX* x)
    ZZ_pX* ZZ_pX_derivative(ZZ_pX* x)
    ZZ_pX* ZZ_pX_reverse(ZZ_pX* x)
    ZZ_pX* ZZ_pX_reverse_hi(ZZ_pX* x, long hi)
    ZZ_pX* ZZ_pX_truncate(ZZ_pX* x, long m)
    ZZ_pX* ZZ_pX_multiply_and_truncate(ZZ_pX* x, ZZ_pX* y, long m)
    ZZ_pX* ZZ_pX_square_and_truncate(ZZ_pX* x, long m)
    ZZ_pX* ZZ_pX_invert_and_truncate(ZZ_pX* x, long m)
    ZZ_pX* ZZ_pX_multiply_mod(ZZ_pX* x, ZZ_pX* y,  ZZ_pX* modulus)
    ZZ_p* ZZ_pX_trace_mod(ZZ_pX* x, ZZ_pX* y)
    char* ZZ_pX_trace_list(ZZ_pX* x)
    ZZ_p* ZZ_pX_resultant(ZZ_pX* x, ZZ_pX* y)
    ZZ_p* ZZ_pX_norm_mod(ZZ_pX* x, ZZ_pX* y)
    ZZ_p* ZZ_pX_discriminant(ZZ_pX* x)
    ZZ_pX* ZZ_pX_charpoly_mod(ZZ_pX* x, ZZ_pX* y)
    ZZ_pX* ZZ_pX_minpoly_mod(ZZ_pX* x, ZZ_pX* y)
    void ZZ_pX_clear(ZZ_pX* x)
    void ZZ_pX_preallocate_space(ZZ_pX* x, long n)
    
    void ZZ_pX_factor(ZZ_pX*** v, long** e, long* n, ZZ_pX* x, long verbose)
    void ZZ_pX_linear_roots(ZZ_p*** v, long* n, ZZ_pX* x)

    #### mat_ZZ
    struct mat_ZZ
    mat_ZZ* new_mat_ZZ(long nrows, long ncols)
    void del_mat_ZZ(mat_ZZ* n)
    char* mat_ZZ_to_str(mat_ZZ* x)
    mat_ZZ* mat_ZZ_add(mat_ZZ* x, mat_ZZ* y)
    mat_ZZ* mat_ZZ_sub(mat_ZZ* x, mat_ZZ* y)
    mat_ZZ* mat_ZZ_mul(mat_ZZ* x, mat_ZZ* y)
    mat_ZZ* mat_ZZ_pow(mat_ZZ* x, long e)
    long mat_ZZ_nrows(mat_ZZ* x)
    long mat_ZZ_ncols(mat_ZZ* x)
    void mat_ZZ_setitem(mat_ZZ* x, int i, int j, ZZ* z)
    ZZ* mat_ZZ_getitem(mat_ZZ* x, int i, int j)
    ZZ* mat_ZZ_determinant(mat_ZZ* x, long deterministic)
    mat_ZZ* mat_ZZ_HNF(mat_ZZ* A, ZZ* D)
    ZZX* mat_ZZ_charpoly(mat_ZZ* A)
