#ifndef FOO_H
#define FOO_H
#include <setjmp.h>
#include <Python.h>
#include <signal.h>

sigjmp_buf env;


#if defined(__CYGWIN32__)
_sig_func_ptr  last, last_handler;
#elif defined(__FreeBSD__)
sig_t last, last_handler;
#elif defined(__APPLE__)
sig_t last, last_handler;
#else
__sighandler_t last, last_handler;
#endif


static PyObject *_m;

void sig_handle(int n);

static int __sig__n, __sig_str__n;

#define _sig_on last = signal(SIGINT, sig_handle); \
                if (last != sig_handle) \
                   last_handler = last; \
                signal(SIGABRT, sig_handle); \
                signal(SIGFPE, sig_handle); \
                if (__sig__n = sigsetjmp(env,1)) {  \
                  if (__sig__n == SIGINT)   \
                      PyErr_SetString(PyExc_KeyboardInterrupt, ""); \
                  else \
                      PyErr_SetString(PyExc_RuntimeError, ""); \
                  return(0); \
	       }

#define _sig_str(s) last = signal(SIGINT, sig_handle); \
                if (last != sig_handle) \
                   last_handler = last; \
                signal(SIGABRT, sig_handle); \
                signal(SIGFPE, sig_handle); \
                if (__sig_str__n = sigsetjmp(env,1)) {  \
		  if(__sig_str__n == SIGINT)		   \
                      PyErr_SetString(PyExc_KeyboardInterrupt, s); \
                  else  \
                      PyErr_SetString(PyExc_RuntimeError, s); \
                  return(0); \
	       }

#define _sig_off signal(SIGINT, last_handler); 


#endif /* FOO_H */



/*
I thought maybe the following would work nicely, instead of just
returning, but no (it crashes sometimes!).  Also the line number is
not set correctly.  The only way I can imagine setting this correctly
is if the following bit of code is generated within pyrex, since pyrex
knows the line numbers.

	             PyErr_SetString(PyExc_RuntimeError, "(complete C-level traceback not available)"); \
		     __pyx_filename = __pyx_f[1]; __pyx_lineno = 0; goto __pyx_L1; \
                }

*/
