"""
8-10-2005
Compute Groebner basis via Singular.


sage.: import sage.interfaces.gap as gap
sage.: Gap = gap.GAP() # please be patient while GAP loads

i="G:=Group((1,2),(1,2,3));"
o = Gap.cmd(i)
o
# _5 = 'Group([ (1,2), (1,2,3) ])'
i="Size(G);"
o = Gap.cmd(i)
o
# _9 = '6'


# Groebner basis via GAP-singular, SAGE example
#  (requires that the GAP "singular" package is
#   installed and configured)

i="LoadPackage(\"singular\");"; o = Gap.cmd(i)
i="R:= PolynomialRing( Rationals, [\"x[0]\",\"x[1]\",\"x[2]\"] );;"; o = Gap.cmd(i)
i="vars:= IndeterminatesOfPolynomialRing(R);;"; o = Gap.cmd(i)
i="x0:= vars[1];; x1:= vars[2];; x2:= vars[3];;"; o = Gap.cmd(i)
i="r:= [ x0*x1*x2 -x0^2*x2, x0^2*x1*x2-x0*x1^2*x2-x0*x1*x2^2, x0*x1-x0*x2-x1*x2];;"; o = Gap.cmd(i)
i="I:= Ideal( R, r );;"; o = Gap.cmd(i)
i="GroebnerBasis( I );"; o = Gap.cmd(i); o
R=MPolynomialRing(QQ,3,"x"); x=R.gens()
exec("L="+o.replace("^","**")); L

## corresponding GAP code (see above)

LoadPackage("singular");
R:= PolynomialRing( Rationals, ["x[0]","x[1]","x[2]"] );;
vars:= IndeterminatesOfPolynomialRing(R);;
x0:= vars[1];; x1:= vars[2];; x2:= vars[3];;
r:= [ x0*x1*x2 -x0^2*x2, x0^2*x1*x2-x0*x1^2*x2-x0*x1*x2^2, x0*x1-x0*x2-x1*x2];;
I:= Ideal( R, r );;
GroebnerBasis( I );

# Groebner basis via Singular, SAGE example

import sage.interfaces.singular as sing
Sing = sing.SING()
i9="ring R=0,(x0,x1,x2),lp; R;"
i10="ideal I1 = [ x0*x1*x2 -x0^2*x2, x0^2*x1*x2-x0*x1^2*x2-x0*x1*x2^2, x0*x1-x0*x2-x1*x2];"
i11="ideal I2=groebner(I1); I2;"
o9 = Sing.cmd(i9); o10 = Sing.cmd(i10); o11 = Sing.cmd(i11)
print o11
#I2[1]=x1^2*x2^2
#I2[2]=x0*x2^3-x1^2*x2^2+x1*x2^3
#I2[3]=x0*x1-x0*x2-x1*x2
#I2[4]=x0^2*x2-x0*x1*x2
s=o11.split("\n")
m=len(s)
ans=list(s[i][6:] for i in range(m)); ans


# corresponding Singular example (as above):
ring R=0,(x0,x1,x2),lp; R;
ideal I1 = [ x0*x1*x2 -x0^2*x2, x0^2*x1*x2-x0*x1^2*x2-x0*x1*x2^2, x0*x1-x0*x2-x1*x2];
ideal I2=groebner(I1); I2;

poly f=(x0+x1)^2*(x1+x2);
poly g=(x0+x1)*(x1-x2);
factorize(f);
gcd(f,g);

poly g=(x0+x1)*(x1-x2)^2;
poly h=(x0+x1)*(x1-x2);
division(g,h);


####

import sage.rings.groebner_basis as gb
R=MPolynomialRing(QQ,3,"x"); x=R.gens()
b = [ x[0]*x[1]*x[2] -x[0]^2*x[2], x[0]^2*x[1]*x[2]-x[0]*x[1]^2*x[2]-x[0]*x[1]*x[2]^2, x[0]*x[1]-x[0]*x[2]-x[1]*x[2]]
#gb.GBviaGAPsingular(b)

ans=gb.gbSingular(b)

f=(x[0]+x[1])**2*(x[1]+x[2])
g=(x[0]+x[1])*(x[1]-x[2])^2
fac=gb.factorSingular(f); fac
eval(fac[0][1])
gcd=gb.gcdSingular(f,g); gcd
eval(gcd)
h=(x[0]+x[1])*(x[1]-x[2])
gb.quotient_remainderSingular(g,h)


R=MPolynomialRing(QQ,3,"t"); t=R.gens()

f=(t[0]+t[1])^2*(t[1]+t[2])
g=(t[0]+t[1])*(t[1]-t[2])^2
fac=gb.factorSingular(f); fac
eval(fac[0][1])
gcd=gb.gcdSingular(f,g); gcd
eval(gcd)
h=(t[0]+t[1])*(t[1]-t[2])
q=gb.quotient_remainderSingular(g,h)
eval(q[0])


#############################################
"""

import sage.interfaces.gap as gap

def GBviaGAPsingular(self):
    print "\n please be patient while GAP loads\n"
    Gap = gap.GAP() 
    R=self[0].parent()
    x=R.gens()
    n=len(x)
    i="LoadPackage(\"singular\");"
    o = Gap.cmd(i)
    varsym=str(x)[1]
    vars=list("\" "+varsym+"["+str(i)+"]\"" for i in range(n))
    i="R:= PolynomialRing( Rationals, "+ str(list(varsym+"["+str(i)+"]" for i in range(n)))  +" );;"
    o = Gap.cmd(i)
    i="vars:= IndeterminatesOfPolynomialRing(R);;"
    o = Gap.cmd(i)
    for i in range(n):
        i=varsym+str(i)+":= vars["+str(i+1)+"];;"
        o = Gap.cmd(i)
    i="r:="+str(self)
    o = Gap.cmd(i)
    i="I:= Ideal( R, r );;"
    o = Gap.cmd(i)
    i="GroebnerBasis( I );"
    o = Gap.cmd(i)
    o.replace("\n","")
#   exec("L="+o.replace("^","**"))  ### SyntaxError: unqualified exec
                                    ### is not allowed in function 'GB'
                                    ### it contains a nested function
                                    ### with free variables (GB.py, line 67)
#   return L    
    return o.replace("^","**")

import sage.interfaces.singular as sing

def gbSingular(self):
    Sing = sing.SING()
    R=self[0].parent()
    x=R.gens()
    varsym=str(x)[1]
    n=len(x)
    char=R.characteristic()
    i9="ring R=%s,%s,lp; R;" %(char,x)
    i10="ideal I1 = "+ str(self)+";"
    i11="ideal I2=groebner(I1); I2;"
    o9 = Sing.cmd(i9); o10 = Sing.cmd(i10); o11 = Sing.cmd(i11)
    s=o11.split("\n")
    m=len(s)
    ans=list(s[i][6:] for i in range(m))
    for j in range(len(ans)):
        poly=ans[j]
        for i in range(n):
            poly=poly.replace(varsym+str(i),varsym+"["+str(i)+"]")      ### only works for variable x???
#       ans[j]=exec(poly) ###### returns SyntaxError
        ans[j]=poly
    return ans


def gcdSingular(self,other):
    Sing = sing.SING()
    R=self.parent()
    x=R.gens()
    varsym=str(x)[1]
    n=len(x)
    char=R.characteristic()
    in1="ring R=%s,%s,lp; R;" %(char,x)
    in2="gcd(%s,%s); " %(self,other)
    out1 = Sing.cmd(in1); out2 = Sing.cmd(in2); 
    poly=out2.split("\n")[0]
    for i in range(n):
        poly=poly.replace(varsym+str(i),varsym+"["+str(i)+"]")     ### only works for variable x???
#       ans=eval(poly)  ###### returns NameError sometimes
        ans=poly
    return ans

def factorSingular(self):
    """
    returns list of irreducible factors as a *string* in 1st component
    the list of multiplicities (the exponents) which irreducible factor occur
    is the 2nd component
    EXAMPLE:
        sage: x = MPolynomialRing(RationalField(),3).gens()
        sage: f=(x[0]+x[1])**2 * (x[1]+x[2])
        sage: fac = factorSingular(f); fac
        [['1', 'x_0+x_1', 'x_1+x_2'], (1, 2, 1)]

    Caution: Singular's list of factors is not normalized in any way,
    so using it as a division test will *not* work.
    """
    Sing = sing.singular
    R=self.parent()
    x=R.gens()
    n=len(x)
    char=R.characteristic()
    varsym=str(x)[1]
    in1="ring R=%s,%s,lp; R;" %(char,x)
    in2="factorize(%s);" %self
    out1 = Sing(in1); out2 = Sing(in2);
    s=out2.split("\n")
    m=len(s)
    ans=list(s[i][8:] for i in range(1,m-2))
    for j in range(len(ans)):
        poly=ans[j]
        for i in range(n):
            poly=poly.replace(varsym+str(i),varsym+"["+str(i)+"]")      ### only works for variable x???
#       ans[j]=eval(poly)          ###### returns mysterious SyntaxError or NameError
        ans[j]=poly
    exps=eval(s[m-1])
    return [ans,exps]

def quotient_remainderSingular(self,other):
    """
    returns the quotient and remainder as a 2-tuple (see Singulars *division* command)
    EXAMPLE:
        sage: x = MPolynomialRing(QQ,3).gens()
        sage: g = (x[0]+x[1])*(x[1]-x[2])**2
        sage: h = (x[0]+x[1])*(x[1]-x[2])
        sage: quotient_remainderSingular(g,h)
        ('x_1-x_2', 0)
    """
    Sing = sing.singular
    R=self.parent()
    x=R.gens()
    varsym=str(x)[1]
    n=len(x)
    char=R.characteristic()
    #char=0
    in1="ring R=%s,%s,lp; R;" %(char,x)
    in2="division(%s,%s);" %(self,other)
    out1 = Sing(in1); out2 = Sing(in2);
    s=out2.split("\n")
    m=len(s)
    quo0=s[1][10:]
    rem0=s[3][8:]
#   print quo0," : \n",rem0
    poly=quo0
    for i in range(n):
            poly=poly.replace(varsym+str(i),varsym+"["+str(i)+"]")     ### only works for variable x???
#   quo=eval(poly) ###### returns SyntaxError or NameError
    quo=poly
    if rem0=="0":
        return (quo, R(0))
    poly=rem0
    for i in range(n):
            poly=poly.replace(varsym+str(i),varsym+"["+str(i)+"]")     ### only works for variable x???
#   rem=eval(poly) ###### returns SyntaxError or NameError
    rem=poly
    return (quo, rem)

            

##############################################################
# For checking that documentation strings are correct.
##############################################################
if __name__ ==  '__main__':
    import doctest, sys
    from multi_polynomial_ring import MPolynomialRing
    from rational_field import RationalField
    QQ = RationalField()
    doctest.testmod(sys.modules[__name__])
